{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}



    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            //Client:{routeName:'BaseController-getComboValues',table:'clients'}
            //,ClientG:{routeName:'BaseController-getComboValues',table:'clients'}
            //,Employee:{routeName:'Employee-getComboValues',table:'employees',modulename:'Employee',fieldId:'code',fieldDisplay:'name'}
            //,EmployeeCR:{routeName:'Employee-getComboValues',table:'employees',modulename:'Employee',fieldId:'code',fieldDisplay:"concat(code,'-',name)"}
            //,EmployeeG:{routeName:'Employee-getComboValues',table:'employees',modulename:'Employee',fieldId:'code',fieldDisplay:'name'}
            //,JobRotation:{routeName:'JobRotation-getComboValues',table:'job_rotations'}
            //,JobRotationG:{routeName:'JobRotation-getComboValues',table:'job_rotations'}
            //,Losttype:{routeName:'LostType-getComboValues',table:'lost_types',limit:250}
            //,LosttypeG:{routeName:'LostType-getComboValues',table:'lost_types',limit:250}
            ProductTree:{routeName:'ProductTree-getComboValues-special',table:'product_trees',fieldId:'name',fieldDisplay:'name',options:{where:'O',finish:null}}
            //,ProductTreeG:{routeName:'ProductTree-getComboValues-special',table:'product_trees',fieldId:'name',fieldDisplay:'name',options:{where:'O',finish:null}}
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);
            t.windowButtons.add=false;
            t.windowButtons.delete=false;
            t.stores.tip=new mj.store({
                data:[{id:'İstasyon',code:'İstasyon'},{id:'Operatör',code:'Operatör'}]
            });
            const gridConfig = {
                cm: [
                    {header: "{{ 'ClientLostDetailDescription.tip'|trans }}", dataIndex: 'tip',width: 60,alias:'cld'},
                    {header: "{{ 'ClientLostDetailDescription.client'|trans }}", dataIndex: 'client',width: 80,filter:'single',alias:'cld',type:'combo',store:t.extras.clients,operator:'='},
                    {header: "{{ 'ClientLostDetailDescription.day'|trans }}", dataIndex: 'day', width: 70,filter:'between',alias:'cld'},
                    {header: "{{ 'ClientLostDetailDescription.jobrotation'|trans }}", dataIndex: 'jobrotation', width: 80,filter:'single',type:'combo',store:t.extras.job_rotations,alias:'cld',operator:'='},
                    {header: "{{ 'ClientLostDetailDescription.employee'|trans }}", dataIndex: 'employee', width: 140,filter:'single', type:'combo',store:t.extras.employees,alias:'cld',operator:'='},
                    {header: "{{ 'ClientLostDetailDescription.opname'|trans }}", dataIndex: 'opname', width: 140,filter:'single',alias:'cld',operator:'%.%'},
                    {header: "{{ 'ClientLostDetailDescription.start'|trans }}", dataIndex: 'start', width: 120,alias:'cld',filter:'between'},
                    {header: "{{ 'ClientLostDetailDescription.finish'|trans }}", dataIndex: 'finish', width: 120,alias:'cld',filter:'between'},
                    {header: "{{ 'ClientLostDetailDescription.suredk'|trans }}", dataIndex: 'suredk', width: 60,alias:'cld',filter:'between', align:'right'},
                    {header: "{{ 'ClientLostDetailDescription.losttype'|trans }}", dataIndex: 'losttype', width: 120,alias:'cld',filter:'single',type:'combo',store:t.extras.lost_types,operator:'=',fieldname:'losttype'}
                    //{header: "{{ 'ClientLostDetailDescription.isrework'|trans }}", dataIndex: 'isrework', width: 50,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'cld'}
                    //{header: "{{ 'ClientLostDetailDescription.issystem'|trans }}", dataIndex: 'issystem', width: 50,renderer:mj.renderer.check(),filter:'single', type:'check',alias:'cld'}
                ]
                ,pbar : new mj.pager({defaultButtons:true,elements: {first:true,prev:true,pages:true,next:true,last:true,selectLimit:true,refresh:false}, limit:10})
            };

            t._setGridConfig(gridConfig);

            const formConfig= {
                items: [
                    new mj.form.fieldSet({
                        id : 'f1',
                        title : '&nbsp;',
                        labelWidth : '110px',
                        width : 240,
                        height : 320,
                        items : [
                            new mj.form.field({
                                dataIndex: 'id',
                                hidden: true
                            }),
                            new mj.form.field({
                                dataIndex: 'version',
                                hidden: true
                            }),
                            new mj.form.field({
                                dataIndex: 'start',
                                hidden: true
                            }),
                            new mj.form.field({
                                dataIndex: 'finish',
                                hidden: true
                            }),
                            new mj.form.combo({
                                title: "{{ 'ClientLostDetailDescription.tip'|trans }}",
                                placeHolder: "{{ 'ClientLostDetailDescription.tip_placeholder'|trans }}",
                                dataIndex: 'tip',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '80px',
                                grid: 's6 m4',
                                store: t.stores.tip,
                                disabled:true
                            }),
                            new mj.form.combo({
                                title: "{{ 'ClientLostDetailDescription.client'|trans }}",
                                placeHolder: "{{ 'ClientLostDetailDescription.client_placeholder'|trans }}",
                                dataIndex: 'client',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '80px',
                                grid: 's6 m4',
                                store: t.extras.clients,
                                disabled:true
                            }),
                            new mj.form.dateField({
                                title: "{{ 'ClientLostDetailDescription.day'|trans }}",
                                dataIndex: 'day',
                                labelWidth : '80px',
                                notEmpty: true,
                                width:80,
                                grid: 's4 m2',
                                disabled:true
                            }),
                            new mj.form.combo({
                                title: "{{ 'ClientLostDetailDescription.jobrotation'|trans }}",
                                placeHolder: "{{ 'ClientLostDetailDescription.jobrotation_placeholder'|trans }}",
                                dataIndex: 'jobrotation',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '80px',
                                grid: 's6 m4',
                                store: t.extras.job_rotations,
                                disabled:true
                            }),
                            new mj.form.combo({
                                title: "{{ 'ClientLostDetailDescription.losttype'|trans }}",
                                placeHolder: "{{ 'ClientLostDetailDescription.losttype_placeholder'|trans }}",
                                dataIndex: 'losttype',
                                mode: 'local',
                                clearOnTriggerClick: true,
                                labelWidth : '80px',
                                grid: 's6 m4',
                                store: t.extras.lost_types,
                                disabled:true
                            }),
                            //new mj.form.checkBox({
                            //    title: "{{ 'ClientLostDetailDescription.ismandatory'|trans }}",
                            //    dataIndex: 'ismandatory',
                            //    itemStyle: 'padding:0 35px 0 0;float:left;',
                            //    labelWidth : '110px',
                            //    grid: 'none'
                            //}),
                            //new mj.form.checkBox({
                            //    title: "{{ 'ClientLostDetailDescription.isrework'|trans }}",
                            //    dataIndex: 'isrework',
                            //    itemStyle: 'padding:0 35px 0 0;float:left;',
                            //    labelWidth : '150px',
                            //    grid: 'none',
                            //    right:true
                            //}),
                            new mj.form.textArea({
                                title: "{{ 'ClientLostDetailDescription.description'|trans }}",
                                dataIndex: 'descriptionlost',
                                maxLength: 255,
                                labelWidth : '80px',
                                width:140,
                                height:80,
                                grid: 's12 m6'
                            }),
                            new mj.form.dateField({
                                title: "{{ 'ClientLostDetailDescription.start'|trans }}",
                                dataIndex: 'start_d',
                                labelWidth : '80px',
                                notEmpty: true,
                                width:80,
                                //maxLength: 19,
                                grid: 's4 m2',
                                disabled:true
                            }),
                            new mj.form.timeField2({
                                title: "",
                                dataIndex: 'start_t',
                                notEmpty: true,
                                labelWidth : '10px',
                                grid: 's12 m6',
                                width:50,
                                right:true,
                                disabled:true
                            }),
                            new mj.form.dateField({
                                title: "{{ 'ClientLostDetailDescription.finish'|trans }}",
                                dataIndex: 'finish_d',
                                labelWidth : '80px',
                                width:80,
                                //maxLength: 19,
                                grid: 's4 m2',
                                disabled:true
                            }),
                            new mj.form.timeField2({
                                title: "",
                                dataIndex: 'finish_t',
                                notEmpty: true,
                                labelWidth : '10px',
                                grid: 's12 m6',
                                width:50,
                                right:true,
                                disabled:true
                            })
                        ]
                    }),
                    new mj.form.fieldSet({
                        id : 'f2',
                        title : "{{ 'ClientLostDetailDescription.opnames'|trans }}",
                        labelWidth : '110px',
                        width : 330,
                        height : 320,
                        style : 'position:absolute;top:0px;left:280px;',
                        items : []
                    }),
                    new mj.form.fieldSet({
                        id : 'f3',
                        title : "{{ 'ClientLostDetailDescription.employees'|trans }}",
                        labelWidth : '110px',
                        width : 300,
                        height : 320,
                        style : 'position:absolute;top:0px;left:645px;',
                        items : []
                    })
                ]
            };
            t._setFormConfig(formConfig);
            var cnt_productions_grid=mj.NE(t.forms.main.items[1].innerEl, {style:'position:absolute;border:1px solid #AFB5AB;left:10px;top:20px;right:10px;bottom:10px;'});
            t.grids.productions = new mj.grid({
                renderTo : cnt_productions_grid,
                store : [],
                pbar : new mj.pager({defaultButtons:false,elements: {selectLimit:false}, limit:null}),
                fitToParent : true,
                sortable : false,
                cm : [
                    {header: "{{ 'ClientLostDetailDescription.erprefnumber'|trans }}", dataIndex: 'erprefnumber', width: 80},
                    {header: "{{ 'ClientLostDetailDescription.opname'|trans }}", dataIndex: 'opname', width: 200},
                    {header: '', width: 1, hide : true}
                ]
            });
            var cnt_employees_grid=mj.NE(t.forms.main.items[2].innerEl, {style:'position:absolute;border:1px solid #AFB5AB;left:10px;top:20px;right:10px;bottom:10px;'});
            t.grids.employees = new mj.grid({
                renderTo : cnt_employees_grid,
                store : [],
                pbar : new mj.pager({defaultButtons:false,elements: {selectLimit:false}, limit:null}),
                fitToParent : true,
                sortable : false,
                cm : [
                    {header: "{{ 'ClientLostDetailDescription.code'|trans }}", dataIndex: 'code', width: 80},
                    {header: "{{ 'ClientLostDetailDescription.employee'|trans }}", dataIndex: 'name', width: 200},
                    {header: '', width: 1, hide : true}
                ]
            });
        },
        editSelectedRecord: function() {
            var t=this
            t.clearProductions();
            t.clearEmployees();
            var selectedRecord = t.getSelectedRecord();
            if (selectedRecord !== false)
                t.editData(selectedRecord);
            //console.log(selectedRecord);
            if(selectedRecord.opnames){
                var productions=selectedRecord.opnames.split('|');
                var tmp=[];
                for(var i=0;i<productions.length;i++){
                    var item=productions[i].split('~');
                    if(tmp.indexOf(item[1])==-1){
                        tmp.push(item[1]);
                        t.grids.productions.store.data.push({erprefnumber:item[0],opname:item[1]});
                    }
                }
                t.grids.productions.load();
            }
            if(selectedRecord.employees){
                var employees=selectedRecord.employees.split('|');
                var tmp=[];
                for(var i=0;i<employees.length;i++){
                    var item=employees[i].split('~');
                    if(tmp.indexOf(item[1])==-1){
                        tmp.push(item[1]);
                        t.grids.employees.store.data.push({code:item[0],name:item[1]});
                    }
                }
                t.grids.employees.load();
            }
        },
        clearProductions : function(){
            var t=this;
            t.grids.productions.store.data=[];
            t.grids.productions.load();
        },
        clearEmployees : function(){
            var t=this;
            t.grids.employees.store.data=[];
            t.grids.employees.load();
        },
        save: function() {
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            t.trigger('beforesave');
            delete f.cachedItems['employee'];
            if (f.modulename && typeof Routing !== 'undefined') {
                    var data = f.getValue();
                    if(data.tip==null||data.tip==''){
                        t.messageShow(t,mj.lng.glb.error,"{{ 'ClientLostDetailDescription.errTipNotSelected'|trans }}");
                        return;
                    }
                    if((data.client==null||data.client=='')&&data.tip=='İstasyon'){
                        t.messageShow(t,mj.lng.glb.error,"{{ 'ClientLostDetailDescription.errnotfoundclient'|trans }}");
                        return;
                    }
                    if(data.day==null||data.day==''){
                        t.messageShow(t,mj.lng.glb.error,"{{ 'ClientLostDetailDescription.errnotfoundday'|trans }}");
                        return;
                    }
                    if(data.jobrotation==''){
                        t.messageShow(t,mj.lng.glb.error,"{{ 'ClientLostDetailDescription.errnotfoundjobrotation'|trans }}");
                        return;
                    }
                    if(data.start_d==null||data.start_t==''){
                        t.messageShow(t,mj.lng.glb.error,"{{ 'ClientLostDetailDescription.errnotfoundstart'|trans }}");
                        return;
                    }
                    if(data.finish_d==null||data.finish_t==''){
                        t.messageShow(t,mj.lng.glb.error,"{{ 'ClientLostDetailDescription.errnotfoundfinish'|trans }}");
                        return;
                    }
                    //if(data.tip=='İstasyon'&&t.grids.productions.store.data.length==0){
                    //    t.messageShow(t,mj.lng.glb.error,"{{ 'ClientLostDetailDescription.errnotfoundproductions'|trans }}");
                    //    return;
                    //}
                    //if(t.grids.employees.store.data.length==0&&data.losttype!=='GÖREVDE KİMSE YOK'){
                    //    t.messageShow(t,mj.lng.glb.error,"{{ 'ClientLostDetailDescription.errnotfoundemployees'|trans }}");
                    //    return;
                    //}
                    var id = data.id;
                    var versionField = f.getField('version');
                    var version = typeof versionField != "undefined" ? data.version : 0;
                    var mode = id ? 'update' : 'add';
                    var routeName = f.modulename + '-' + mode;
                    var route = Routing.getRoute(routeName);
                    var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                        'pg': t.grids.main.pbar.current,
                        'lm': t.grids.main.pbar.limit
                    } : {};
                    var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                        'id': id,
                        'v': version
                    }) : pagerParams);
                    
                    data.menuId = t.id;
                    data.productions=t.grids.productions.store.data;
                    data.employees=t.grids.employees.store.data;
                    if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                        t.waitMaskShow();
                        t._event='save';
                        $.ajax({
                            url: url,
                            method: "POST",
                            data: JSON.stringify(data),
                            headers: { 
                                "Content-Type": "application/json",
                                "X-HTTP-Method-Override": route.methods[0] 
                            },
                            dataType: 'json',
                            success: function(data, textStatus, jqXHR) {
                                t.reset(_f, data);
                                //t.activateTabGrid();
                                //t.waitMaskHide();
                            },
                            error: function(jqXHR, textStatus, errorThrown) {
                                t.waitMaskHide();
                                mj.message({
                                    title: mj.lng.glb.error,
                                    msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
                                    type: "error",
                                    html: true
                                });
                            },
                            complete: function(jqXHR, textStatus) {
                                //t.waitMaskHide();
                            }
                        });
                    }
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
